"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var node_fetch_1 = __importDefault(require("node-fetch"));
var events_1 = require("events");
var utils_1 = require("../utils");
var structures_1 = require("../structures");
var enums_1 = require("../enums");
/** Represents a client that connects to Transformice. */
var Client = /** @class */ (function (_super) {
    __extends(Client, _super);
    function Client() {
        var _this = _super.call(this) || this;
        _this.loops = {};
        _this.version = 0;
        _this.connectionKey = "";
        _this.authClient = 0;
        _this.identificationKeys = [];
        _this.msgKeys = [];
        _this.authServer = 0;
        _this.ports = [];
        _this.host = "";
        _this.tribulleID = 0;
        _this.onlinePlayers = 0;
        _this.playerID = 0;
        _this.nickname = "";
        _this.playingTime = 0;
        _this.connectionTime = 0;
        _this.community = 0;
        _this.language = "";
        _this.pcode = 0;
        _this.main = new utils_1.Connection(_this, "main");
        _this.bulle = new utils_1.Connection(_this, "bulle");
        return _this;
    }
    /**
     * Handles the old packets and emits events.
     */
    Client.prototype.handleOldPacket = function (conn, ccc, data) {
        if (ccc == enums_1.oldIdentifiers.roomPlayerLeft) {
            var player = this.room.getPlayer(+data[0]);
            if (player) {
                this.room.removePlayer(player);
                this.emit("roomPlayerLeft", player);
            }
        }
        this.emit("rawOldPacket", conn, ccc, data);
    };
    /**
     * Handles the known packets and emits events.
     */
    Client.prototype.handlePacket = function (conn, packet) {
        var _this = this;
        var ccc = packet.readUnsignedShort();
        if (ccc == enums_1.identifiers.oldPacket) {
            var data = packet.readUTF().split(String.fromCharCode(1));
            var a = data.splice(0, 1)[0];
            var ccc_1 = (a.charCodeAt(0) << 8) | a.charCodeAt(1);
            this.handleOldPacket(conn, ccc_1, data);
        }
        else if (ccc == enums_1.identifiers.handshakeOk) {
            this.onlinePlayers = packet.readUnsignedInt();
            this.language = packet.readUTF();
            packet.readUTF(); // country;
            this.authServer = packet.readUnsignedInt();
            this.setSystemInfo("en", "Linux", "LNX 29,0,0,140");
            this.startHeartbeat();
        }
        else if (ccc == enums_1.identifiers.loginReady) {
            this.emit("loginReady");
        }
        else if (ccc == enums_1.identifiers.fingerprint) {
            conn.fingerprint = packet.readByte();
        }
        else if (ccc == enums_1.identifiers.bulleConnection) {
            var timestamp_1 = packet.readUnsignedInt();
            var playerId_1 = packet.readUnsignedInt();
            var pcode_1 = packet.readUnsignedInt();
            var host = packet.readUTF();
            packet
                .readUTF()
                .split("-")
                .map(function (port) { return ~~port; }); // port
            if (this.bulle.open)
                this.bulle.close();
            this.bulle = new utils_1.Connection(this, "bulle");
            this.bulle.connect(host, this.ports[0]);
            this.bulle.on("connect", function () {
                _this.bulle.send(enums_1.identifiers.bulleConnection, new utils_1.ByteArray()
                    .writeUnsignedInt(timestamp_1)
                    .writeUnsignedInt(playerId_1)
                    .writeUnsignedInt(pcode_1));
            });
        }
        else if (ccc == enums_1.identifiers.logged) {
            this.playerID = packet.readUnsignedInt();
            this.nickname = packet.readUTF();
            this.playingTime = packet.readUnsignedInt();
            this.connectionTime = new Date().getTime();
            this.community = packet.readByte();
            this.pcode = packet.readUnsignedInt();
            this.emit("logged", this.nickname, this.pcode);
        }
        else if (ccc == enums_1.identifiers.bulle) {
            var code = packet.readUnsignedShort();
            if (code == 3) {
                this.emit("ready");
            }
            else {
                this.handleTribulle(code, packet);
            }
        }
        else if (ccc == enums_1.identifiers.luaChatLog) {
            this.emit("luaLog", packet.readUTF());
        }
        else if (ccc == enums_1.identifiers.roomMessage) {
            var player = this.room.getPlayer(packet.readUTF());
            if (!player)
                return;
            var content = packet.readUTF();
            var message = new structures_1.RoomMessage(this, player, content);
            this.emit("roomMessage", message);
        }
        else if (ccc == enums_1.identifiers.roomChange) {
            var before = this.room;
            var isPublic = packet.readBoolean(), name_1 = packet.readUTF(), language = packet.readUTF();
            this.room = new structures_1.Room(this, isPublic, name_1, language);
            this.emit("roomChange", before, this.room);
        }
        else if (ccc == enums_1.identifiers.roomPlayerList) {
            var before = this.room.playerList;
            this.room.playerList = [];
            var length_1 = packet.readUnsignedShort();
            for (var i = 0; i < length_1; i++) {
                var player = new structures_1.Player().read(packet);
                this.room.playerList.push(player);
            }
            this.player = this.room.getPlayer(this.pcode);
            this.emit("roomUpdate", before, this.room.playerList);
        }
        else if (ccc == enums_1.identifiers.roomNewPlayer) {
            var player = new structures_1.Player().read(packet);
            if (this.room.getPlayer(player.pcode)) {
                this.emit("roomPlayerUpdate", this.room.getPlayer(player.pcode), player);
            }
            else {
                this.emit("roomPlayerJoin", player);
            }
            this.room.updatePlayer(player);
        }
        else if (ccc == enums_1.identifiers.languageChange) {
            var language = packet.readUTF();
            var country = packet.readUTF();
            var readRight = packet.readBoolean();
            var readSpecialChar = packet.readBoolean();
            this.emit("languageChange", language, country, readRight, readSpecialChar);
        }
        else {
            //console.log(c, cc, packet.buffer);
        }
        this.emit("rawPacket", conn, ccc, packet);
    };
    /**
     * Handles the community platform packets and emits events.
     */
    Client.prototype.handleTribulle = function (code, packet) {
        if (code == 66) {
            var author = packet.readUTF();
            var community = packet.readUnsignedInt();
            var sentTo = packet.readUTF();
            var content = packet.readUTF();
            var message = new structures_1.WhisperMessage(this, author, community, sentTo, content);
            this.emit("whisper", message);
        }
        else if (code == 34) {
            var friends = [];
            var soulmate = new structures_1.Friend().read(packet, true); // soulmate
            var hasSoulmate = !(soulmate.id == 0 && soulmate.nickname == "");
            if (hasSoulmate)
                friends.push(soulmate);
            var totalFriends = packet.readUnsignedShort();
            while (totalFriends--) {
                friends.push(new structures_1.Friend().read(packet, false));
            }
            this.emit("friendList", friends, hasSoulmate ? soulmate.nickname : null);
        }
        this.emit("rawTribulle", code, packet);
    };
    /**
     * Sends a packet to the community platform (tribulle).
     */
    Client.prototype.sendTribullePacket = function (code, packet) {
        this.tribulleID = (this.tribulleID % 0x100000000) + 1;
        var p = new utils_1.ByteArray().writeShort(code).writeUnsignedInt(this.tribulleID);
        p.writeBytes(packet);
        this.main.send(enums_1.identifiers.bulle, p, enums_1.cipherMethods.xor);
    };
    /**
     * Log in to the game.
     */
    Client.prototype.login = function (nickname, password, room) {
        if (room === void 0) { room = "1"; }
        var p = new utils_1.ByteArray().writeUTF(nickname).writeUTF(utils_1.SHAKikoo(password));
        p.writeUTF("app:/TransformiceAIR.swf/[[DYNAMIC]]/2/[[DYNAMIC]]/4").writeUTF(room);
        p.writeUnsignedInt(parseInt((BigInt(this.authServer) ^ BigInt(this.authClient)).toString()));
        this.main.send(enums_1.identifiers.loginSend, p, enums_1.cipherMethods.xxtea);
    };
    /**
     * Sends Handshake.
     */
    Client.prototype.sendHandshake = function (version, key) {
        var p = new utils_1.ByteArray();
        p.writeShort(version);
        p.writeUTF("en");
        p.writeUTF(key);
        p.writeUTF("Desktop").writeUTF("-").writeInt(0x1fbd);
        p.writeUTF("");
        p.writeUTF("ca26ba3ada3fc0aadba7d94e5677bee000333d8f46bab4c3cb32e615587e7212");
        p.writeUTF("A=t&SA=t&SV=t&EV=t&MP3=t&AE=t&VE=t&ACC=t&PR=t&SP=f&SB=f&DEB=f&V=LNX 29,0,0,140&M=Adobe Linux&R=1920x1080&COL=color&AR=1.0&OS=Linux&ARCH=x86&L=en&IME=t&PR32=t&PR64=t&LS=en-US&PT=Desktop&AVD=f&LFD=f&WD=f&TLS=t&ML=5.1&DP=72");
        p.writeInt(0).writeInt(0x1234).writeUTF("");
        this.main.send(enums_1.identifiers.handshake, p);
    };
    /**
     * Sets the language of the client.
     * @param {enums.language} [id=enums.language.en] - The language iso code.
     */
    Client.prototype.setLanguage = function (code) {
        if (code === void 0) { code = enums_1.languages.en; }
        if (typeof code !== "string")
            code = enums_1.languages.en;
        var p = new utils_1.ByteArray().writeUTF(code);
        this.main.send(enums_1.identifiers.language, p);
    };
    Client.prototype.setSystemInfo = function (langue, sys, version) {
        var p = new utils_1.ByteArray().writeUTF(langue).writeUTF(sys).writeUTF(version);
        this.main.send(enums_1.identifiers.os, p);
    };
    /**
     * Joins the tribe house.
     */
    Client.prototype.joinTribeHouse = function () {
        this.main.send(enums_1.identifiers.joinTribeHouse, new utils_1.ByteArray());
    };
    /**
     * Load a lua script in the room.
     */
    Client.prototype.loadLua = function (script) {
        var length = Buffer.byteLength(script);
        var p = new utils_1.ByteArray().writeUnsignedShort(length >> 8).writeUnsignedByte(length & 255);
        this.bulle.send(enums_1.identifiers.loadLua, p);
    };
    /**
     * Sends a message to the client's room.
     * @param {String} message - The message.
     */
    Client.prototype.sendRoomMessage = function (message) {
        this.bulle.send(enums_1.identifiers.roomMessage, new utils_1.ByteArray().writeUTF(message), enums_1.cipherMethods.xor);
    };
    /**
     * Sends a server command.
     * @param message - The command message (without the `/`).
     * @example
     * client.sendCommand('mod');
     */
    Client.prototype.sendCommand = function (message) {
        this.main.send(enums_1.identifiers.command, new utils_1.ByteArray().writeUTF(message), enums_1.cipherMethods.xor);
    };
    /**
     * Sends a request to the server to join a room with specific name.
     */
    Client.prototype.joinRoom = function (name, isSalonAuto) {
        if (isSalonAuto === void 0) { isSalonAuto = false; }
        this.main.send(enums_1.identifiers.room, new utils_1.ByteArray()
            .writeUTF("")
            .writeUTF(name)
            .writeByte(isSalonAuto ? 1 : 0));
    };
    /**
     * Sends a whisper message to a player.
     */
    Client.prototype.sendWhisper = function (nickname, message) {
        this.sendTribullePacket(52, new utils_1.ByteArray().writeUTF(nickname.toLowerCase()).writeUTF(message));
    };
    /**
     * Request friend list.
     */
    Client.prototype.requestFriendList = function () {
        this.sendTribullePacket(28, new utils_1.ByteArray());
    };
    /**
     * Sends a packet every 15 seconds to stay connected to the game.
     */
    Client.prototype.startHeartbeat = function () {
        var _this = this;
        this.main.send(enums_1.identifiers.heartbeat, new utils_1.ByteArray());
        this.loops.heartbeat = setInterval(function () {
            _this.main.send(enums_1.identifiers.heartbeat, new utils_1.ByteArray());
            if (_this.bulle.open)
                _this.bulle.send(enums_1.identifiers.heartbeat, new utils_1.ByteArray());
        }, 1000 * 15);
    };
    /**
     * Starts the client.
     */
    Client.prototype.run = function (tfmid, token, nickname, password, language, room) {
        if (language === void 0) { language = enums_1.languages.en; }
        if (room === void 0) { room = "1"; }
        return __awaiter(this, void 0, void 0, function () {
            var response, result;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, node_fetch_1.default("https://api.tocuto.tk/get_transformice_keys.php?tfmid=" + tfmid + "&token=" + token)];
                    case 1:
                        response = _a.sent();
                        return [4 /*yield*/, response.json()];
                    case 2:
                        result = _a.sent();
                        if (result.success) {
                            if (!result.internal_error) {
                                this.version = result.version;
                                this.connectionKey = result.connection_key;
                                this.ports = result.ports;
                                this.host = result.ip;
                                this.authClient = result.auth_key;
                                this.identificationKeys = result.identification_keys;
                                this.msgKeys = result.msg_keys;
                                this.main = new utils_1.Connection(this, "main");
                                this.main.connect(this.host, this.ports[0]);
                                this.main.on("connect", function () {
                                    _this.sendHandshake(_this.version, _this.connectionKey);
                                });
                                this.on("loginReady", function () {
                                    _this.setLanguage(language);
                                    _this.login(nickname, password, room);
                                });
                            }
                            else {
                                if (result.internal_error_step == 2)
                                    throw new Error("The game might be in maintenance mode.");
                                throw new Error("An internal error occur: " + result.internal_error_step);
                            }
                        }
                        else {
                            throw new Error("Can't get the keys : " + result.error);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Disconnects the client.
     */
    Client.prototype.disconnect = function () {
        clearInterval(this.loops.heartbeat);
        this.main.close();
        this.bulle.close();
        this.emit("disconnect");
    };
    return Client;
}(events_1.EventEmitter));
exports.default = Client;
