import { ValueOf, ByteArray } from "../utils";
import { genders } from "../enums";
/** Represents a friend from the friend list */
export default class Friend {
    /**
     * The player's id
     */
    id: number;
    /**
     * The player's nickname
     */
    nickname: string;
    /**
     * The player's gender
     */
    gender: ValueOf<typeof genders>;
    /**
     * If the player is the soulmate of the client
     */
    isSoulmate: boolean;
    /**
     * If the player has added the client back
     */
    hasAddedBack: boolean;
    /**
     * If the player is connected
     */
    isConnected: boolean;
    /**
     * The community of the player
     */
    community: number;
    /**
     * The room name of the player (if they are online)
     */
    roomName: string;
    /**
     * The player's last connection time
     */
    lastConnection: number;
    constructor();
    /**
     * Returns friend data from a packet
     */
    read(packet: ByteArray, isSoulmate: boolean): this;
}
