"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/** Represents a friend from the friend list */
var Friend = /** @class */ (function () {
    function Friend() {
        this.id = 0;
        this.nickname = "";
        this.gender = 0;
        this.isSoulmate = false;
        this.hasAddedBack = false;
        this.isConnected = false;
        this.community = 0;
        this.roomName = "";
        this.lastConnection = 0;
    }
    /**
     * Returns friend data from a packet
     */
    Friend.prototype.read = function (packet, isSoulmate) {
        this.id = packet.readInt();
        this.nickname = packet.readUTF();
        this.gender = packet.readByte();
        packet.readInt(); // ?
        this.isSoulmate = isSoulmate;
        this.hasAddedBack = packet.readBoolean();
        this.isConnected = packet.readBoolean();
        this.community = packet.readInt();
        this.roomName = packet.readUTF();
        this.lastConnection = packet.readInt();
        return this;
    };
    return Friend;
}());
exports.default = Friend;
