"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/** Represents a player from the room. */
var Player = /** @class */ (function () {
    function Player() {
        this.nickname = "";
        this.gender = 0;
        this.look = "";
        this.pcode = 0;
        this.title = 0;
        this.titleStars = 0;
        this.hasCheese = false;
        this.isDead = false;
        this.isShaman = false;
        this.isVampire = false;
        this.score = 0;
        this.mouseColor = 0;
        this.nameColor = -1;
        this.shamanColor = 0;
        this.facingRight = true;
        this.movingLeft = false;
        this.movingRight = false;
        this.x = 0;
        this.y = 0;
        this.vx = 0;
        this.vy = 0;
        this.isJumping = false;
    }
    /**
     * Reads player data from a packet.
     */
    Player.prototype.read = function (packet) {
        this.nickname = packet.readUTF();
        this.pcode = packet.readUnsignedInt();
        this.isShaman = packet.readBoolean();
        this.isDead = packet.readBoolean();
        this.score = packet.readUnsignedShort();
        this.hasCheese = packet.readBoolean();
        this.title = packet.readUnsignedShort();
        this.titleStars = packet.readByte() - 1;
        this.gender = packet.readByte();
        packet.readUTF(); // Unknown string
        this.look = packet.readUTF();
        packet.readBoolean(); // Unknown boolean
        this.mouseColor = packet.readUnsignedInt();
        this.shamanColor = packet.readUnsignedInt();
        packet.readUnsignedInt(); // Unknown int
        var color = packet.readUnsignedInt();
        this.nameColor = color == 0xffffffff ? -1 : color;
        return this;
    };
    return Player;
}());
exports.default = Player;
