"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
var enums_1 = require("../enums");
/** Represents a room. */
var Room = /** @class */ (function () {
    function Room(client, isPublic, name, language) {
        this.client = client;
        this.name = name;
        this.playerList = [];
        this.isPublic = isPublic;
        this.language = language;
        this.isTribeHouse = name.charCodeAt(1) === 3;
    }
    Room.prototype.getPlayer = function (value) {
        if (typeof value === "number")
            return this.playerList.find(function (p) { return p.pcode === value; });
        else if (typeof value === "string")
            return this.playerList.find(function (p) { return p.nickname === value; });
    };
    /**
     * Removes player the player from room playerList.
     */
    Room.prototype.removePlayer = function (player) {
        var index = this.playerList.findIndex(function (p) { return (p.pcode = player.pcode); });
        if (index === -1)
            return;
        return this.playerList.splice(index, 1)[0];
    };
    /**
     * Adds or updates the player in room playerList.
     */
    Room.prototype.updatePlayer = function (player) {
        var playerToUpdate = this.getPlayer(player.pcode);
        playerToUpdate = player;
        return playerToUpdate;
    };
    /**
     * Sends a message to the room.
     */
    Room.prototype.sendMessage = function (message) {
        this.client.bulle.send(enums_1.identifiers.roomMessage, new utils_1.ByteArray().writeUTF(message), enums_1.cipherMethods.xor);
    };
    return Room;
}());
exports.default = Room;
