import { Player, Message } from ".";
import Client from "../client";
/** Represents a room message. */
export default class RoomMessage extends Message {
    constructor(client: Client, author: Player, content: string);
    /**
     * Reply the author with a message.
     * @example
     * client.on('roomMessage', (message) => {
     * 	if (client.nickname == message.author.nickname)
     * 		return;
     * 	message.reply('Hello');
     * }
     */
    reply(message: string): void;
}
