import { Player, Message } from ".";
import Client from "../client";
/** Represents a whisper message. */
export default class WhisperMessage extends Message {
    /**
     * The player name who sent to them.
     */
    sentTo: string;
    community: number;
    constructor(client: Client, author: Player | string, community: number, sentTo: string, content: string);
    /**
     * Reply the author with a whisper message
     * @example
     * client.on('whisper', (message) => {
     * 	if (client.nickname == message.author)
     * 		return;
     * 	message.reply('Hello');
     * }
     */
    reply(message: string): void;
}
